Con                                      ''s2 direct wheel motor control
  _clkmode = xtal1 + pll16x       
  _xinfreq = 5_000_000   

  pwm = 16                               ''pwm base io for s2
  
Var
  
Obj
 
  pw : "pwmx8"                           ''pwm object
   
Pub main  
    
  pw.start(16, %00001100, 20_000)        ''start pwm object on pwm base i/o pin @ 20khz
  dira[16..17]~~                         ''set s2's motor direction control i/o pins to output

  repeat
              'left      right
    move_robot(-75,      255)            ''set s2's left wheel slow reverse, set s2's right wheel maximum forward
                                                
  
Pub move_robot(left_wheel, right_wheel)  ''set s2's left & right wheel motor's speed from -255 maximum reverse to 255 maximum forward, 0 = stop                                                                       
                                                                                                                                         
  left_wheel := -255 #> left_wheel <# 255                                                                                                
  right_wheel := -255 #> right_wheel <# 255
                                                                                               
  ifnot right_wheel & $80_00_00_00     
    outa[pwm + 1] := 1                                                                                                   
    pw.duty(pwm + 3, right_wheel & $ff)                                                                                                  
  else                                                                                                                                   
    outa[pwm + 1] := 0                                                                                                                  
    pw.duty(pwm + 3, (0 - right_wheel) & $ff)
                                                                                                
  ifnot left_wheel & $80_00_00_00
    outa[pwm] := 1
    pw.duty(pwm + 2, left_wheel & $ff)                                                                                                   
  else
    outa[pwm] := 0                                                                                                              
    pw.duty(pwm + 2, (0 - left_wheel) & $ff)
                                                                                                                         